%undefine _package_note_flags
%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname logs

Name:           ocaml-%{srcname}
Version:        0.7.0
Release:        3%{?dist}
Summary:        Logging infrastructure for OCaml

License:        ISC
URL:            https://erratique.ch/software/logs
Source0:        %{url}/releases/%{srcname}-%{version}.tbz

BuildRequires:  ocaml >= 4.03.0
BuildRequires:  ocaml-cmdliner-devel
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-fmt-devel
BuildRequires:  ocaml-lwt-devel
BuildRequires:  ocaml-mtime-devel
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-topkg-devel

%description
Logs provides a logging infrastructure for OCaml.  Logging is performed
on sources whose reporting level can be set independently.  The log
message report is decoupled from logging and is handled by a reporter.

A few optional log reporters are distributed with the base library and
the API lets you easily implement your own.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-cmdliner-devel%{?_isa}
Requires:       ocaml-fmt-devel%{?_isa}
Requires:       ocaml-lwt-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%prep
%autosetup -n %{srcname}-%{version}

# test_lwt needs the thread flag
sed -i 's/package(lwt)/thread, &/' _tags

%build
ocaml pkg/pkg.ml build --with-js_of_ocaml false --with-fmt true \
  --with-cmdliner true --with-lwt true --with-base-threads true --tests true

# Relink with Fedora linker flags
cd _build
ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g -I src src/logs.cmxa \
  -o src/logs.cmxs
ocamlfind ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g -package fmt \
  -I src src/logs_fmt.cmxa -o src/logs_fmt.cmxs
ocamlfind ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g \
  -package cmdliner -I src src/logs_cli.cmxa -o src/logs_cli.cmxs
ocamlfind ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g -thread \
  -package lwt -I src src/logs_lwt.cmxa -o src/logs_lwt.cmxs
ocamlfind ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g \
  -package compiler-libs.toplevel -I src src/logs_top.cmxa -o src/logs_top.cmxs
ocamlfind ocamlopt -shared -linkall -cclib '%{build_ldflags}' -g -thread \
  -package threads -I src src/logs_threaded.cmxa -o src/logs_threaded.cmxs
cd -

%install
mkdir -p %{buildroot}%{_libdir}/ocaml/%{srcname}
cp -p _build/src/*.{a,cma,cmi,cmt,cmti,cmx,cmxa,cmxs,mli} _build/pkg/META \
   _build/opam %{buildroot}%{_libdir}/ocaml/%{srcname}

# The tests don't do us much good.  Several of them deliberately log errors,
# to test that that works, but the tests are written so that any logged errors
# at all makes the test suite exit with exit value 1.  It would be great if
# upstream would exit with 0 on a normal run...
#%%check
#ocaml pkg/pkg.ml test || :

%files
%doc CHANGES.md README.md
%license LICENSE.md
%dir %{_libdir}/ocaml/%{srcname}/
%{_libdir}/ocaml/%{srcname}/META
%{_libdir}/ocaml/%{srcname}/*.cma
%{_libdir}/ocaml/%{srcname}/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/*.cmxs
%endif

%files         devel
%if %{with docs}
%doc _build/default/_doc/*
%endif
%{_libdir}/ocaml/%{srcname}/opam
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/*.a
%{_libdir}/ocaml/%{srcname}/*.cmx
%{_libdir}/ocaml/%{srcname}/*.cmxa
%endif
%{_libdir}/ocaml/%{srcname}/*.cmt
%{_libdir}/ocaml/%{srcname}/*.cmti
%{_libdir}/ocaml/%{srcname}/*.mli

%changelog
* Fri Feb 04 2022 Richard W.M. Jones <rjones@redhat.com> - 0.7.0-3
- OCaml 4.13.1 rebuild to remove package notes

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Dec  6 2021 Jerry James <loganjerry@gmail.com> - 0.7.0-1
- Initial RPM
